struct EulerEquation{T_EoS<:EquationOfState.AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
  Pρ::Float64 # Prandtl number for NaSt regularization of density
  PT::Float64 # Prandtl number for NaSt regularization of energy
end

struct EulerEquation2d{T_EoS<:EquationOfState.AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
end


mutable struct Project{T_Equation <:EulerEquation,
                       T_HRSC     <:Maybe{HRSC.AbstractHRSC},
                       T_TCI      <:Maybe{TCI.AbstractTCI},
                       T_BC,
                       T_Prms<:NamedTuple}

  equation::T_Equation
  hrsc::T_HRSC
  tci::T_TCI
  bdrycond::T_BC
  prms::T_Prms
end

mutable struct Project2d{T_Equation <:EulerEquation2d,
                         T_HRSC     <:Maybe{HRSC.AbstractHRSC},
                         T_TCI      <:Maybe{TCI.AbstractTCI}}

  equation::T_Equation
  hrsc::T_HRSC
  tci::T_TCI
end
